#!/usr/bin/env ruby
require 'cgi'
require 'stringio'
require 'timeout'

def test_read_multipart_eof_fix
  boundary = "ABC1234XYZeee"
  data = <<end_of_data.gsub(/\n/, "\r\n")
--#{boundary}
Content-Disposition: form-data; name="MalformedData"


abcd
-#{boundary}--
end_of_data

  ENV['REQUEST_METHOD'] = "POST"
  ENV['CONTENT_TYPE']   = "multipart/form-data; boundary=#{boundary}"
  ENV['CONTENT_LENGTH'] = data.length.to_s

  $stdin = StringIO.new(data)

  begin
    Timeout.timeout(2) { CGI.new }
  rescue EOFError
    $stderr.puts ' => CGI is safe: read_multipart raises EOFError on malformed multipart requests.'
  rescue TimeoutError
    $stderr.puts ' => CGI is exploitable: read_multipart hangs on malformed multipart requests.'
  end
end

$stderr.puts 'Testing malformed multipart request parsing'
test_read_multipart_eof_fix

$stderr.puts 'Patching CGI::QueryExtension.read_multipart'
require 'rubygems'
require 'cgi_multipart_eof_fix'

test_read_multipart_eof_fix
